/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ScatterTriangulationSeries } from "./ScatterTriangulationSeries";
import { ColorScale } from "./ColorScale";
import { runOn, delegateRemove, delegateCombine, typeCast, Point_$type, markType, markDep } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { FastItemIntColumn } from "igniteui-react-core";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { SeriesView } from "./SeriesView";
import { TriangleRasterizer } from "./TriangleRasterizer";
import { ScalerParams } from "./ScalerParams";
import { ObservableColorCollection } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
import { ColorUtil } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { CustomPaletteColorScale } from "./CustomPaletteColorScale";
import { DataLegendSeriesValueInfo } from "igniteui-react-core";
import { DataLegendSeriesContext } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, intDivide } from "igniteui-react-core";
import { boxArray$1 } from "igniteui-react-core";
import { RenderingContext } from "igniteui-react-core";
import { CanvasViewRenderer } from "igniteui-react-core";
import { Rectangle } from "igniteui-react-core";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
export let ScatterAreaSeries = /*@__PURE__*/ (() => {
    class ScatterAreaSeries extends ScatterTriangulationSeries {
        get_d8() {
            return true;
        }
        constructor() {
            super();
            this.vw = null;
            this.v1 = null;
            this.vu = null;
            this.vv = null;
            FastItemIntColumn.m();
            this.ab = ScatterAreaSeries.$;
        }
        get vy() {
            return this.vw;
        }
        set vy(a) {
            let b = this.vw != a;
            if (b) {
                let c = this.vw;
                if (this.vw != null) {
                    let d = this.vw;
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.wf));
                }
                this.vw = a;
                if (this.vw != null) {
                    let e = this.vw;
                    e.propertyChanged = delegateCombine(e.propertyChanged, runOn(this, this.wf));
                }
                this.raisePropertyChanged("ColorScale", c, this.vw);
            }
        }
        wf(a, b) {
            this.wh();
            this.pp(false);
        }
        ju(a, b) {
            let c = this.lv(b);
            if (c == ScatterAreaSeries.$$p[3]) {
                return this.jv(a, b, this.wa);
            }
            return super.ju(a, b);
        }
        get v2() {
            return this.v1;
        }
        set v2(a) {
            let b = this.v2 != a;
            if (b) {
                let c = this.v2;
                this.v1 = a;
                this.raisePropertyChanged("ColorColumn", c, this.v2);
            }
        }
        get_gf() {
            return true;
        }
        set_gf(a) {
            super.set_gf(a);
        }
        o8(a, b, c, d) {
            super.o8(a, b, c, d);
            switch (b) {
                case "FastItemsSource":
                    let e = typeCast(IFastItemsSource_$type, c);
                    if (e != null) {
                        e.deregisterColumn(this.v2);
                        this.v2 = null;
                    }
                    let f = typeCast(IFastItemsSource_$type, d);
                    if (f != null) {
                        this.v2 = this.c3(this.wa);
                    }
                    this.pp(this.fq && c != null);
                    break;
                case ScatterAreaSeries.$$p[3]:
                    if (this.c6 != null) {
                        this.c6.deregisterColumn(this.v2);
                        this.v2 = this.c3(this.wa);
                    }
                    this.pp(false);
                    this.ol();
                    break;
                case "ColorScale":
                    this.wh();
                    this.pp(false);
                    this.ol();
                    break;
            }
        }
        pq(a) {
            super.pq(a);
            this.wg(this.cj);
        }
        po(a, b, c, d, e) {
            super.po(a, b, c, d, e);
            let f = this.a7.a$h.item(d);
            f.a3(c);
            if (this.dl(f)) {
                return;
            }
            this.wg(f);
        }
        wg(a) {
            if (this.dl(a)) {
                return;
            }
            let b;
            let c;
            let d = a.getViewInfo(c, b);
            c = d.p0;
            b = d.p1;
            let e = a;
            let f = null;
            let g = null;
            let h = this.t1;
            let i = this.t2;
            let j = this.getEffectiveViewport1(a);
            let k = new ScalerParams(1, b, c, h.ch);
            k.c = j;
            let l = new ScalerParams(1, b, c, i.ch);
            l.c = j;
            g = this.v0(a, k, l);
            if (g != null) {
                e.cb(g);
            }
            else {
                e.ce(f);
            }
        }
        wd(a) {
            let b;
            let c;
            let d = a.getViewInfo(b, c);
            b = d.p0;
            c = d.p1;
            let e = truncate(Math.round(b.width)) * truncate(Math.round(b.height));
            let f = a.b3;
            if (f == null || f.length != e) {
                f = new Array(e);
                for (let g = 0; g < e; g++) {
                    f[g] = 0;
                }
            }
            else {
                for (let h = 0; h < e; h++) {
                    f[h] = 0;
                }
            }
            a.b3 = f;
        }
        jr(a) {
            let b = truncate(Math.round(this.tw.width));
            let c = truncate(Math.round(this.tw.height));
            let d = this.cj.b3;
            if (d == null || d.length != (b * c) || this.ub == null || this.ub.count < 1 || this.uc == null || this.uc.count < 1 || this.ud == null || this.ud.count < 1) {
                return null;
            }
            let e = this.cy.t3;
            let f = (a.x - e.left) / e.width;
            let g = (a.y - e.top) / e.height;
            let h = truncate(Math.round(b * f));
            let i = truncate(Math.round(c * g));
            let j = (b * i) + h;
            if (j < 0 || j > d.length - 1) {
                return null;
            }
            let k = d[j] - 1;
            if (k < 0 || k > this.ub.count) {
                return null;
            }
            let l = this.vu.length;
            let m = this.ub.item(k);
            let n = this.uc.item(k);
            let o = this.ud.item(k);
            if ((m >= l) || (n >= l) || (o >= l)) {
                return null;
            }
            let p = (this.vu[m] - this.tw.left) / this.tw.width;
            let q = (this.vv[m] - this.tw.top) / this.tw.height;
            let r = (this.vu[n] - this.tw.left) / this.tw.width;
            let s = (this.vv[n] - this.tw.top) / this.tw.height;
            let t = (this.vu[o] - this.tw.left) / this.tw.width;
            let u = (this.vv[o] - this.tw.top) / this.tw.height;
            let v = Math.pow(p - f, 2) + Math.pow(q - g, 2);
            let w = Math.pow(r - f, 2) + Math.pow(s - g, 2);
            let x = Math.pow(t - f, 2) + Math.pow(u - g, 2);
            if (v < w && v < x) {
                return this.c6.item(m);
            }
            if (w < v && w < x) {
                return this.c6.item(n);
            }
            if (x < v && x < w) {
                return this.c6.item(o);
            }
            return this.c6.item(m);
        }
        v0(a, b, c) {
            let d;
            let e;
            let f = a.getViewInfo(e, d);
            e = f.p0;
            d = f.p1;
            e = new Rect(0, 0, 0, e.width, e.height);
            b = new ScalerParams(0, b.e, e, b.a, b.c);
            c = new ScalerParams(0, c.e, e, c.a, c.c);
            c.b = this.h2();
            let g = a;
            let h = this.t1;
            let i = this.t2;
            let j = this.ub.count;
            let k;
            let xArr_ = this.ue.asArray();
            k = (xArr_.slice(0));
            let l;
            let yArr_ = this.uf.asArray();
            l = (yArr_.slice(0));
            let m = this.v2.asArray();
            let n = this.ub.asArray();
            let o = this.uc.asArray();
            let p = this.ud.asArray();
            this.vu = k;
            this.vv = l;
            h.hn(boxArray$1(k), 0, k.length, b);
            i.hn(boxArray$1(l), 0, l.length, c);
            let q = this.vx;
            let r = g.b5(b.d, q, this.v2);
            let s = e.top;
            let t = e.left;
            let u = e.right;
            let v = e.bottom;
            let w;
            let x;
            let y;
            let z;
            this.wd(g);
            let aa = g.b3;
            let ab = k.length;
            for (let ac = 0; ac < j; ac++) {
                let ad = n[ac];
                let ae = o[ac];
                let af = p[ac];
                if ((ad >= ab) || (ae >= ab) || (af >= ab) || (ad < 0) || (ae < 0) || (af < 0)) {
                    continue;
                }
                let ag = k[ad];
                let ah = l[ad];
                let ai = { $type: Point_$type, x: ag, y: ah };
                let aj = k[ae];
                let ak = l[ae];
                let al = { $type: Point_$type, x: aj, y: ak };
                let am = k[af];
                let an = l[af];
                let ao = { $type: Point_$type, x: am, y: an };
                w = al.y < ao.y ? al.y : ao.y;
                w = ai.y < w ? ai.y : w;
                x = al.y > ao.y ? al.y : ao.y;
                x = ai.y > x ? ai.y : x;
                y = al.x < ao.x ? al.x : ao.x;
                y = ai.x < y ? ai.x : y;
                z = al.x > ao.x ? al.x : ao.x;
                z = ai.x > z ? ai.x : z;
                if (w < v && x > s && y < u && z > t) {
                    let ap = m[ad];
                    let aq = m[ae];
                    let ar = m[af];
                    r.p(ac, aa, ai, al, ao, ap, aq, ar);
                }
            }
            return r;
        }
        v3() {
            let a = new Color();
            let b = this.ss;
            if (b == null) {
                a = ColorUtil.r("#000000");
            }
            else {
                a = ColorUtil.q(b);
            }
            let c = new ObservableColorCollection();
            c.add(ColorUtil.v(a, -0.5));
            c.add(a);
            return c;
        }
        wh() {
            let a = this.vy;
            if (a == null) {
                a = ((() => {
                    let $ret = new CustomPaletteColorScale();
                    $ret.palette = this.v3();
                    $ret.interpolationMode = 2;
                    return $ret;
                })());
            }
            else if (typeCast(CustomPaletteColorScale.$, a) !== null) {
                let b = a;
                if (b.palette == null || b.palette.count == 0) {
                    b.palette = this.v3();
                }
                a = b;
            }
            let c = new ObservableColorCollection();
            if (typeCast(CustomPaletteColorScale.$, a) !== null) {
                c = a.palette;
            }
            else {
                c = this.v3();
            }
            this.vx = a;
        }
        qd() {
            super.qd();
            this.wh();
        }
        nj(a, b) {
            super.nj(a, b);
            let c = b;
            c.ca();
        }
        cg() {
            return new ScatterAreaSeriesView(this);
        }
        o0(a) {
            super.o0(a);
            this.vz = typeCast(ScatterAreaSeriesView.$, a);
        }
        we(a) {
            if (this.vz != null) {
                this.vz.b9(a);
            }
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = { $type: Point_$type, x: a, y: b };
            let d = this.jr(c);
            let e = d == null ? NaN : this.h1(d, "XMemberPath");
            let f = d == null ? NaN : this.h1(d, "YMemberPath");
            let g = d == null ? NaN : this.h1(d, "ColorMemberPath");
            let h = new DataLegendSeriesValueInfo();
            h.l = e;
            h.a = 13;
            h.p = "X";
            h.q = this.u3 != null ? this.u3 : "X";
            h.r = this.uz != null ? this.uz : "X:";
            h.s = this.u1 != null ? this.u1 : "";
            let i = new DataLegendSeriesValueInfo();
            i.l = f;
            i.a = 14;
            i.p = "Y";
            i.q = this.vb != null ? this.vb : "Y";
            i.r = this.u7 != null ? this.u7 : "Y:";
            i.s = this.u9 != null ? this.u9 : "";
            let j = new DataLegendSeriesValueInfo();
            j.l = g;
            j.a = 0;
            j.p = "Value";
            j.q = this.wa != null ? this.wa : "Value";
            j.r = this.v6 != null ? this.v6 : "V:";
            j.s = this.v8 != null ? this.v8 : "";
            let k = new DataLegendSeriesContext();
            k.f = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(h);
                $ret.add(i);
                $ret.add(j);
                return $ret;
            })());
            k.b = this.aw();
            return k;
        }
    }
    ScatterAreaSeries.$t = /*@__PURE__*/ markType(ScatterAreaSeries, 'ScatterAreaSeries', ScatterTriangulationSeries.$);
    ScatterAreaSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, ScatterAreaSeries, 'raisePropertyChanged', ['ActualColorScale:vx:wi', [ColorScale.$, null], 'ColorMemberAsLegendLabel:v6:wj', [2, null], 'ColorMemberAsLegendUnit:v8:wk', [2, null], 'ColorMemberPath:wa:wl', [2, null]]);
    return ScatterAreaSeries;
})();
/**
 * @hidden
 */
export let ScatterAreaSeriesView = /*@__PURE__*/ (() => {
    class ScatterAreaSeriesView extends SeriesView {
        get b3() {
            return this.b0;
        }
        set b3(a) {
            this.b0 = a;
        }
        constructor(a) {
            super(a);
            this.b4 = null;
            this.b0 = null;
            this.b8 = null;
            this.b7 = null;
            this.b6 = null;
            this.b4 = a;
        }
        cd(a, b) {
        }
        b9(a) {
        }
        b1() {
            return this.b2(true);
        }
        b2(a) {
            this.cc();
            let b = truncate(Math.round(this.bx.left));
            let c = truncate(Math.round(this.bx.left));
            let d = truncate(Math.round(this.bx.width));
            let e = truncate(Math.round(this.bx.height));
            let f = d.toString();
            let g = e.toString();
            if (this.b7.getAttribute("width") != f) {
                this.b7.setAttribute("width", d.toString());
            }
            if (this.b7.getAttribute("height") != g) {
                this.b7.setAttribute("height", e.toString());
            }
            let h = this.b6.h();
            if (a) {
                h.clearRect(0, 0, d, e);
            }
            this.b8 = h.getImageData(0, 0, d, e);
            let imageDataArray_ = this.b8.data;
            return imageDataArray_;
        }
        cc() {
            if (this.b7 == null) {
                this.b7 = this.e.i4.createElement("canvas");
                let a = this.e.i4.get2DCanvasContext(this.b7);
                this.b6 = new RenderingContext(new CanvasViewRenderer(), a);
            }
        }
        b5(a, b, c) {
            let d = truncate(Math.round(this.bx.left));
            let e = truncate(Math.round(this.bx.left));
            let f = truncate(Math.round(this.bx.width));
            let g = truncate(Math.round(this.bx.height));
            return new TriangleRasterizer(this.b1(), b, c.minimum, c.maximum, c, f, g);
        }
        cb(a) {
            this.ce(null);
        }
        ca() {
            if (this.b6 != null) {
                this.b6.l(this.bx.left, this.bx.top, this.bx.width, this.bx.height);
            }
            this.as();
        }
        a8(a, b) {
            super.a8(a, b);
            if (this.b7 == null) {
                return;
            }
            if (b) {
                let c = new Rectangle();
                c.n = this.bx.left;
                c.o = this.bx.top;
                c.width = this.bx.width;
                c.height = this.bx.height;
                c._fill = this.br();
                a.w(c);
            }
            else {
                let d = truncate(Math.round(this.bx.left));
                let e = truncate(Math.round(this.bx.top));
                let f = truncate(Math.round(this.bx.width));
                let g = truncate(Math.round(this.bx.height));
                a.n(this.b7.getNativeElement(), 1, d, e, f, g);
            }
        }
        ce(a) {
            let b = truncate(Math.round(this.bx.left));
            let c = truncate(Math.round(this.bx.left));
            let d = truncate(Math.round(this.bx.width));
            let e = truncate(Math.round(this.bx.height));
            this.cc();
            this.b6.h().putImageData(this.b8, 0, 0);
            this.as();
        }
        an(a) {
            super.an(a);
            let b = truncate(Math.round(this.bx.width));
            let c = truncate(Math.round(this.bx.height));
            let d = this.b2(false);
            if (d == null || d.length == 0) {
                this.e.a9.exportSeriesPixelsData(a, null, b, c);
                return;
            }
            let e = new Array(intDivide(d.length, 4));
            let f;
            for (let g = 0; g < intDivide(d.length, 4); g++) {
                f = g * 4;
                e[g] = d[f + 3] << 24 | d[f] << 16 | d[f + 1] << 8 | d[f + 2];
            }
            this.e.a9.exportSeriesPixelsData(a, e, b, c);
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.a7.a$r(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.b4.title + "</span><br/><span>" + "(${item." + this.b4.u3 + "}, ${item." + this.b4.vb + "})</span>";
            if (!stringIsNullOrEmpty(this.b4.wa)) {
                a += "<span>, Value: ${item." + this.b4.wa + "}</span>";
            }
            a += "</div>";
            return a;
        }
    }
    ScatterAreaSeriesView.$t = /*@__PURE__*/ markType(ScatterAreaSeriesView, 'ScatterAreaSeriesView', SeriesView.$);
    return ScatterAreaSeriesView;
})();
